diff --git a/src/backend/utils/time/tqual.c b/src/backend/utils/time/tqual.c
new file mode 100644
index 519f3b6..66ecd7f
*** a/src/backend/utils/time/tqual.c
--- b/src/backend/utils/time/tqual.c
*************** HeapTupleSatisfiesSelf(HeapTuple htup, S
*** 224,230 ****
  				}
  			}
  		}
! 		else if (TransactionIdIsCurrentTransactionId(HeapTupleHeaderGetRawXmin(tuple)))
  		{
  			if (tuple->t_infomask & HEAP_XMAX_INVALID)	/* xid invalid */
  				return true;
--- 224,230 ----
  				}
  			}
  		}
! 		else if (TransactionIdIsCurrentTransactionId(HeapTupleGetRawXmin(htup)))
  		{
  			if (tuple->t_infomask & HEAP_XMAX_INVALID)	/* xid invalid */
  				return true;
*************** HeapTupleSatisfiesSelf(HeapTuple htup, S
*** 236,242 ****
  			{
  				TransactionId xmax;
  
! 				xmax = HeapTupleGetUpdateXid(tuple);
  
  				/* not LOCKED_ONLY, so it has to have an xmax */
  				Assert(TransactionIdIsValid(xmax));
--- 236,242 ----
  			{
  				TransactionId xmax;
  
! 				xmax = HeapTupleGetUpdateXid(htup);
  
  				/* not LOCKED_ONLY, so it has to have an xmax */
  				Assert(TransactionIdIsValid(xmax));
*************** HeapTupleSatisfiesSelf(HeapTuple htup, S
*** 248,254 ****
  					return false;
  			}
  
! 			if (!TransactionIdIsCurrentTransactionId(HeapTupleHeaderGetRawXmax(tuple)))
  			{
  				/* deleting subtransaction must have aborted */
  				SetHintBits(tuple, buffer, HEAP_XMAX_INVALID,
--- 248,254 ----
  					return false;
  			}
  
! 			if (!TransactionIdIsCurrentTransactionId(HeapTupleGetRawXmax(htup)))
  			{
  				/* deleting subtransaction must have aborted */
  				SetHintBits(tuple, buffer, HEAP_XMAX_INVALID,
*************** HeapTupleSatisfiesSelf(HeapTuple htup, S
*** 258,268 ****
  
  			return false;
  		}
! 		else if (TransactionIdIsInProgress(HeapTupleHeaderGetRawXmin(tuple)))
  			return false;
! 		else if (TransactionIdDidCommit(HeapTupleHeaderGetRawXmin(tuple)))
  			SetHintBits(tuple, buffer, HEAP_XMIN_COMMITTED,
! 						HeapTupleHeaderGetRawXmin(tuple));
  		else
  		{
  			/* it must have aborted or crashed */
--- 258,268 ----
  
  			return false;
  		}
! 		else if (TransactionIdIsInProgress(HeapTupleGetRawXmin(htup)))
  			return false;
! 		else if (TransactionIdDidCommit(HeapTupleGetRawXmin(htup)))
  			SetHintBits(tuple, buffer, HEAP_XMIN_COMMITTED,
! 						HeapTupleGetRawXmin(htup));
  		else
  		{
  			/* it must have aborted or crashed */
*************** HeapTupleSatisfiesSelf(HeapTuple htup, S
*** 291,297 ****
  		if (HEAP_XMAX_IS_LOCKED_ONLY(tuple->t_infomask))
  			return true;
  
! 		xmax = HeapTupleGetUpdateXid(tuple);
  
  		/* not LOCKED_ONLY, so it has to have an xmax */
  		Assert(TransactionIdIsValid(xmax));
--- 291,297 ----
  		if (HEAP_XMAX_IS_LOCKED_ONLY(tuple->t_infomask))
  			return true;
  
! 		xmax = HeapTupleGetUpdateXid(htup);
  
  		/* not LOCKED_ONLY, so it has to have an xmax */
  		Assert(TransactionIdIsValid(xmax));
*************** HeapTupleSatisfiesSelf(HeapTuple htup, S
*** 306,322 ****
  		return true;
  	}
  
! 	if (TransactionIdIsCurrentTransactionId(HeapTupleHeaderGetRawXmax(tuple)))
  	{
  		if (HEAP_XMAX_IS_LOCKED_ONLY(tuple->t_infomask))
  			return true;
  		return false;
  	}
  
! 	if (TransactionIdIsInProgress(HeapTupleHeaderGetRawXmax(tuple)))
  		return true;
  
! 	if (!TransactionIdDidCommit(HeapTupleHeaderGetRawXmax(tuple)))
  	{
  		/* it must have aborted or crashed */
  		SetHintBits(tuple, buffer, HEAP_XMAX_INVALID,
--- 306,322 ----
  		return true;
  	}
  
! 	if (TransactionIdIsCurrentTransactionId(HeapTupleGetRawXmax(htup)))
  	{
  		if (HEAP_XMAX_IS_LOCKED_ONLY(tuple->t_infomask))
  			return true;
  		return false;
  	}
  
! 	if (TransactionIdIsInProgress(HeapTupleGetRawXmax(htup)))
  		return true;
  
! 	if (!TransactionIdDidCommit(HeapTupleGetRawXmax(htup)))
  	{
  		/* it must have aborted or crashed */
  		SetHintBits(tuple, buffer, HEAP_XMAX_INVALID,
*************** HeapTupleSatisfiesSelf(HeapTuple htup, S
*** 334,340 ****
  	}
  
  	SetHintBits(tuple, buffer, HEAP_XMAX_COMMITTED,
! 				HeapTupleHeaderGetRawXmax(tuple));
  	return false;
  }
  
--- 334,340 ----
  	}
  
  	SetHintBits(tuple, buffer, HEAP_XMAX_COMMITTED,
! 				HeapTupleGetRawXmax(htup));
  	return false;
  }
  
*************** HeapTupleSatisfiesToast(HeapTuple htup, 
*** 421,427 ****
  		 * is canceled by super-deleting the tuple.  This also applies to
  		 * TOAST tuples created during speculative insertion.
  		 */
! 		else if (!TransactionIdIsValid(HeapTupleHeaderGetXmin(tuple)))
  			return false;
  	}
  
--- 421,427 ----
  		 * is canceled by super-deleting the tuple.  This also applies to
  		 * TOAST tuples created during speculative insertion.
  		 */
! 		else if (!TransactionIdIsValid(HeapTupleGetXmin(htup)))
  			return false;
  	}
  
*************** HeapTupleSatisfiesUpdate(HeapTuple htup,
*** 509,515 ****
  				}
  			}
  		}
! 		else if (TransactionIdIsCurrentTransactionId(HeapTupleHeaderGetRawXmin(tuple)))
  		{
  			if (HeapTupleHeaderGetCmin(tuple) >= curcid)
  				return HeapTupleInvisible;		/* inserted after scan started */
--- 509,515 ----
  				}
  			}
  		}
! 		else if (TransactionIdIsCurrentTransactionId(HeapTupleGetRawXmin(htup)))
  		{
  			if (HeapTupleHeaderGetCmin(tuple) >= curcid)
  				return HeapTupleInvisible;		/* inserted after scan started */
*************** HeapTupleSatisfiesUpdate(HeapTuple htup,
*** 521,527 ****
  			{
  				TransactionId xmax;
  
! 				xmax = HeapTupleHeaderGetRawXmax(tuple);
  
  				/*
  				 * Careful here: even though this tuple was created by our own
--- 521,527 ----
  			{
  				TransactionId xmax;
  
! 				xmax = HeapTupleGetRawXmax(htup);
  
  				/*
  				 * Careful here: even though this tuple was created by our own
*************** HeapTupleSatisfiesUpdate(HeapTuple htup,
*** 552,558 ****
  			{
  				TransactionId xmax;
  
! 				xmax = HeapTupleGetUpdateXid(tuple);
  
  				/* not LOCKED_ONLY, so it has to have an xmax */
  				Assert(TransactionIdIsValid(xmax));
--- 552,558 ----
  			{
  				TransactionId xmax;
  
! 				xmax = HeapTupleGetUpdateXid(htup);
  
  				/* not LOCKED_ONLY, so it has to have an xmax */
  				Assert(TransactionIdIsValid(xmax));
*************** HeapTupleSatisfiesUpdate(HeapTuple htup,
*** 560,566 ****
  				/* deleting subtransaction must have aborted */
  				if (!TransactionIdIsCurrentTransactionId(xmax))
  				{
! 					if (MultiXactIdIsRunning(HeapTupleHeaderGetRawXmax(tuple),
  											 false))
  						return HeapTupleBeingUpdated;
  					return HeapTupleMayBeUpdated;
--- 560,566 ----
  				/* deleting subtransaction must have aborted */
  				if (!TransactionIdIsCurrentTransactionId(xmax))
  				{
! 					if (MultiXactIdIsRunning(HeapTupleGetRawXmax(htup),
  											 false))
  						return HeapTupleBeingUpdated;
  					return HeapTupleMayBeUpdated;
*************** HeapTupleSatisfiesUpdate(HeapTuple htup,
*** 576,582 ****
  				}
  			}
  
! 			if (!TransactionIdIsCurrentTransactionId(HeapTupleHeaderGetRawXmax(tuple)))
  			{
  				/* deleting subtransaction must have aborted */
  				SetHintBits(tuple, buffer, HEAP_XMAX_INVALID,
--- 576,582 ----
  				}
  			}
  
! 			if (!TransactionIdIsCurrentTransactionId(HeapTupleGetRawXmax(htup)))
  			{
  				/* deleting subtransaction must have aborted */
  				SetHintBits(tuple, buffer, HEAP_XMAX_INVALID,
*************** HeapTupleSatisfiesUpdate(HeapTuple htup,
*** 589,599 ****
  			else
  				return HeapTupleInvisible;		/* updated before scan started */
  		}
! 		else if (TransactionIdIsInProgress(HeapTupleHeaderGetRawXmin(tuple)))
  			return HeapTupleInvisible;
! 		else if (TransactionIdDidCommit(HeapTupleHeaderGetRawXmin(tuple)))
  			SetHintBits(tuple, buffer, HEAP_XMIN_COMMITTED,
! 						HeapTupleHeaderGetRawXmin(tuple));
  		else
  		{
  			/* it must have aborted or crashed */
--- 589,599 ----
  			else
  				return HeapTupleInvisible;		/* updated before scan started */
  		}
! 		else if (TransactionIdIsInProgress(HeapTupleGetRawXmin(htup)))
  			return HeapTupleInvisible;
! 		else if (TransactionIdDidCommit(HeapTupleGetRawXmin(htup)))
  			SetHintBits(tuple, buffer, HEAP_XMIN_COMMITTED,
! 						HeapTupleGetRawXmin(htup));
  		else
  		{
  			/* it must have aborted or crashed */
*************** HeapTupleSatisfiesUpdate(HeapTuple htup,
*** 624,640 ****
  
  		if (HEAP_XMAX_IS_LOCKED_ONLY(tuple->t_infomask))
  		{
! 			if (MultiXactIdIsRunning(HeapTupleHeaderGetRawXmax(tuple), true))
  				return HeapTupleBeingUpdated;
  
  			SetHintBits(tuple, buffer, HEAP_XMAX_INVALID, InvalidTransactionId);
  			return HeapTupleMayBeUpdated;
  		}
  
! 		xmax = HeapTupleGetUpdateXid(tuple);
  		if (!TransactionIdIsValid(xmax))
  		{
! 			if (MultiXactIdIsRunning(HeapTupleHeaderGetRawXmax(tuple), false))
  				return HeapTupleBeingUpdated;
  		}
  
--- 624,640 ----
  
  		if (HEAP_XMAX_IS_LOCKED_ONLY(tuple->t_infomask))
  		{
! 			if (MultiXactIdIsRunning(HeapTupleGetRawXmax(htup), true))
  				return HeapTupleBeingUpdated;
  
  			SetHintBits(tuple, buffer, HEAP_XMAX_INVALID, InvalidTransactionId);
  			return HeapTupleMayBeUpdated;
  		}
  
! 		xmax = HeapTupleGetUpdateXid(htup);
  		if (!TransactionIdIsValid(xmax))
  		{
! 			if (MultiXactIdIsRunning(HeapTupleGetRawXmax(htup), false))
  				return HeapTupleBeingUpdated;
  		}
  
*************** HeapTupleSatisfiesUpdate(HeapTuple htup,
*** 649,655 ****
  				return HeapTupleInvisible;		/* updated before scan started */
  		}
  
! 		if (MultiXactIdIsRunning(HeapTupleHeaderGetRawXmax(tuple), false))
  			return HeapTupleBeingUpdated;
  
  		if (TransactionIdDidCommit(xmax))
--- 649,655 ----
  				return HeapTupleInvisible;		/* updated before scan started */
  		}
  
! 		if (MultiXactIdIsRunning(HeapTupleGetRawXmax(htup), false))
  			return HeapTupleBeingUpdated;
  
  		if (TransactionIdDidCommit(xmax))
*************** HeapTupleSatisfiesUpdate(HeapTuple htup,
*** 660,666 ****
  		 * what about the other members?
  		 */
  
! 		if (!MultiXactIdIsRunning(HeapTupleHeaderGetRawXmax(tuple), false))
  		{
  			/*
  			 * There's no member, even just a locker, alive anymore, so we can
--- 660,666 ----
  		 * what about the other members?
  		 */
  
! 		if (!MultiXactIdIsRunning(HeapTupleGetRawXmax(htup), false))
  		{
  			/*
  			 * There's no member, even just a locker, alive anymore, so we can
*************** HeapTupleSatisfiesUpdate(HeapTuple htup,
*** 677,683 ****
  		}
  	}
  
! 	if (TransactionIdIsCurrentTransactionId(HeapTupleHeaderGetRawXmax(tuple)))
  	{
  		if (HEAP_XMAX_IS_LOCKED_ONLY(tuple->t_infomask))
  			return HeapTupleBeingUpdated;
--- 677,683 ----
  		}
  	}
  
! 	if (TransactionIdIsCurrentTransactionId(HeapTupleGetRawXmax(htup)))
  	{
  		if (HEAP_XMAX_IS_LOCKED_ONLY(tuple->t_infomask))
  			return HeapTupleBeingUpdated;
*************** HeapTupleSatisfiesUpdate(HeapTuple htup,
*** 687,696 ****
  			return HeapTupleInvisible;	/* updated before scan started */
  	}
  
! 	if (TransactionIdIsInProgress(HeapTupleHeaderGetRawXmax(tuple)))
  		return HeapTupleBeingUpdated;
  
! 	if (!TransactionIdDidCommit(HeapTupleHeaderGetRawXmax(tuple)))
  	{
  		/* it must have aborted or crashed */
  		SetHintBits(tuple, buffer, HEAP_XMAX_INVALID,
--- 687,696 ----
  			return HeapTupleInvisible;	/* updated before scan started */
  	}
  
! 	if (TransactionIdIsInProgress(HeapTupleGetRawXmax(htup)))
  		return HeapTupleBeingUpdated;
  
! 	if (!TransactionIdDidCommit(HeapTupleGetRawXmax(htup)))
  	{
  		/* it must have aborted or crashed */
  		SetHintBits(tuple, buffer, HEAP_XMAX_INVALID,
*************** HeapTupleSatisfiesUpdate(HeapTuple htup,
*** 708,714 ****
  	}
  
  	SetHintBits(tuple, buffer, HEAP_XMAX_COMMITTED,
! 				HeapTupleHeaderGetRawXmax(tuple));
  	return HeapTupleUpdated;	/* updated by other */
  }
  
--- 708,714 ----
  	}
  
  	SetHintBits(tuple, buffer, HEAP_XMAX_COMMITTED,
! 				HeapTupleGetRawXmax(htup));
  	return HeapTupleUpdated;	/* updated by other */
  }
  
*************** HeapTupleSatisfiesDirty(HeapTuple htup, 
*** 791,797 ****
  				}
  			}
  		}
! 		else if (TransactionIdIsCurrentTransactionId(HeapTupleHeaderGetRawXmin(tuple)))
  		{
  			if (tuple->t_infomask & HEAP_XMAX_INVALID)	/* xid invalid */
  				return true;
--- 791,797 ----
  				}
  			}
  		}
! 		else if (TransactionIdIsCurrentTransactionId(HeapTupleGetRawXmin(htup)))
  		{
  			if (tuple->t_infomask & HEAP_XMAX_INVALID)	/* xid invalid */
  				return true;
*************** HeapTupleSatisfiesDirty(HeapTuple htup, 
*** 803,809 ****
  			{
  				TransactionId xmax;
  
! 				xmax = HeapTupleGetUpdateXid(tuple);
  
  				/* not LOCKED_ONLY, so it has to have an xmax */
  				Assert(TransactionIdIsValid(xmax));
--- 803,809 ----
  			{
  				TransactionId xmax;
  
! 				xmax = HeapTupleGetUpdateXid(htup);
  
  				/* not LOCKED_ONLY, so it has to have an xmax */
  				Assert(TransactionIdIsValid(xmax));
*************** HeapTupleSatisfiesDirty(HeapTuple htup, 
*** 815,821 ****
  					return false;
  			}
  
! 			if (!TransactionIdIsCurrentTransactionId(HeapTupleHeaderGetRawXmax(tuple)))
  			{
  				/* deleting subtransaction must have aborted */
  				SetHintBits(tuple, buffer, HEAP_XMAX_INVALID,
--- 815,821 ----
  					return false;
  			}
  
! 			if (!TransactionIdIsCurrentTransactionId(HeapTupleGetRawXmax(htup)))
  			{
  				/* deleting subtransaction must have aborted */
  				SetHintBits(tuple, buffer, HEAP_XMAX_INVALID,
*************** HeapTupleSatisfiesDirty(HeapTuple htup, 
*** 825,831 ****
  
  			return false;
  		}
! 		else if (TransactionIdIsInProgress(HeapTupleHeaderGetRawXmin(tuple)))
  		{
  			/*
  			 * Return the speculative token to caller.  Caller can worry about
--- 825,831 ----
  
  			return false;
  		}
! 		else if (TransactionIdIsInProgress(HeapTupleGetRawXmin(htup)))
  		{
  			/*
  			 * Return the speculative token to caller.  Caller can worry about
*************** HeapTupleSatisfiesDirty(HeapTuple htup, 
*** 841,853 ****
  				Assert(snapshot->speculativeToken != 0);
  			}
  
! 			snapshot->xmin = HeapTupleHeaderGetRawXmin(tuple);
  			/* XXX shouldn't we fall through to look at xmax? */
  			return true;		/* in insertion by other */
  		}
! 		else if (TransactionIdDidCommit(HeapTupleHeaderGetRawXmin(tuple)))
  			SetHintBits(tuple, buffer, HEAP_XMIN_COMMITTED,
! 						HeapTupleHeaderGetRawXmin(tuple));
  		else
  		{
  			/* it must have aborted or crashed */
--- 841,853 ----
  				Assert(snapshot->speculativeToken != 0);
  			}
  
! 			snapshot->xmin = HeapTupleGetRawXmin(htup);
  			/* XXX shouldn't we fall through to look at xmax? */
  			return true;		/* in insertion by other */
  		}
! 		else if (TransactionIdDidCommit(HeapTupleGetRawXmin(htup)))
  			SetHintBits(tuple, buffer, HEAP_XMIN_COMMITTED,
! 						HeapTupleGetRawXmin(htup));
  		else
  		{
  			/* it must have aborted or crashed */
*************** HeapTupleSatisfiesDirty(HeapTuple htup, 
*** 876,882 ****
  		if (HEAP_XMAX_IS_LOCKED_ONLY(tuple->t_infomask))
  			return true;
  
! 		xmax = HeapTupleGetUpdateXid(tuple);
  
  		/* not LOCKED_ONLY, so it has to have an xmax */
  		Assert(TransactionIdIsValid(xmax));
--- 876,882 ----
  		if (HEAP_XMAX_IS_LOCKED_ONLY(tuple->t_infomask))
  			return true;
  
! 		xmax = HeapTupleGetUpdateXid(htup);
  
  		/* not LOCKED_ONLY, so it has to have an xmax */
  		Assert(TransactionIdIsValid(xmax));
*************** HeapTupleSatisfiesDirty(HeapTuple htup, 
*** 894,914 ****
  		return true;
  	}
  
! 	if (TransactionIdIsCurrentTransactionId(HeapTupleHeaderGetRawXmax(tuple)))
  	{
  		if (HEAP_XMAX_IS_LOCKED_ONLY(tuple->t_infomask))
  			return true;
  		return false;
  	}
  
! 	if (TransactionIdIsInProgress(HeapTupleHeaderGetRawXmax(tuple)))
  	{
  		if (!HEAP_XMAX_IS_LOCKED_ONLY(tuple->t_infomask))
! 			snapshot->xmax = HeapTupleHeaderGetRawXmax(tuple);
  		return true;
  	}
  
! 	if (!TransactionIdDidCommit(HeapTupleHeaderGetRawXmax(tuple)))
  	{
  		/* it must have aborted or crashed */
  		SetHintBits(tuple, buffer, HEAP_XMAX_INVALID,
--- 894,914 ----
  		return true;
  	}
  
! 	if (TransactionIdIsCurrentTransactionId(HeapTupleGetRawXmax(htup)))
  	{
  		if (HEAP_XMAX_IS_LOCKED_ONLY(tuple->t_infomask))
  			return true;
  		return false;
  	}
  
! 	if (TransactionIdIsInProgress(HeapTupleGetRawXmax(htup)))
  	{
  		if (!HEAP_XMAX_IS_LOCKED_ONLY(tuple->t_infomask))
! 			snapshot->xmax = HeapTupleGetRawXmax(htup);
  		return true;
  	}
  
! 	if (!TransactionIdDidCommit(HeapTupleGetRawXmax(htup)))
  	{
  		/* it must have aborted or crashed */
  		SetHintBits(tuple, buffer, HEAP_XMAX_INVALID,
*************** HeapTupleSatisfiesDirty(HeapTuple htup, 
*** 926,932 ****
  	}
  
  	SetHintBits(tuple, buffer, HEAP_XMAX_COMMITTED,
! 				HeapTupleHeaderGetRawXmax(tuple));
  	return false;				/* updated by other */
  }
  
--- 926,932 ----
  	}
  
  	SetHintBits(tuple, buffer, HEAP_XMAX_COMMITTED,
! 				HeapTupleGetRawXmax(htup));
  	return false;				/* updated by other */
  }
  
*************** HeapTupleSatisfiesMVCC(HeapTuple htup, S
*** 1012,1018 ****
  				}
  			}
  		}
! 		else if (TransactionIdIsCurrentTransactionId(HeapTupleHeaderGetRawXmin(tuple)))
  		{
  			if (HeapTupleHeaderGetCmin(tuple) >= snapshot->curcid)
  				return false;	/* inserted after scan started */
--- 1012,1018 ----
  				}
  			}
  		}
! 		else if (TransactionIdIsCurrentTransactionId(HeapTupleGetRawXmin(htup)))
  		{
  			if (HeapTupleHeaderGetCmin(tuple) >= snapshot->curcid)
  				return false;	/* inserted after scan started */
*************** HeapTupleSatisfiesMVCC(HeapTuple htup, S
*** 1027,1033 ****
  			{
  				TransactionId xmax;
  
! 				xmax = HeapTupleGetUpdateXid(tuple);
  
  				/* not LOCKED_ONLY, so it has to have an xmax */
  				Assert(TransactionIdIsValid(xmax));
--- 1027,1033 ----
  			{
  				TransactionId xmax;
  
! 				xmax = HeapTupleGetUpdateXid(htup);
  
  				/* not LOCKED_ONLY, so it has to have an xmax */
  				Assert(TransactionIdIsValid(xmax));
*************** HeapTupleSatisfiesMVCC(HeapTuple htup, S
*** 1041,1047 ****
  					return false;		/* updated before scan started */
  			}
  
! 			if (!TransactionIdIsCurrentTransactionId(HeapTupleHeaderGetRawXmax(tuple)))
  			{
  				/* deleting subtransaction must have aborted */
  				SetHintBits(tuple, buffer, HEAP_XMAX_INVALID,
--- 1041,1047 ----
  					return false;		/* updated before scan started */
  			}
  
! 			if (!TransactionIdIsCurrentTransactionId(HeapTupleGetRawXmax(htup)))
  			{
  				/* deleting subtransaction must have aborted */
  				SetHintBits(tuple, buffer, HEAP_XMAX_INVALID,
*************** HeapTupleSatisfiesMVCC(HeapTuple htup, S
*** 1054,1064 ****
  			else
  				return false;	/* deleted before scan started */
  		}
! 		else if (XidInMVCCSnapshot(HeapTupleHeaderGetRawXmin(tuple), snapshot))
  			return false;
! 		else if (TransactionIdDidCommit(HeapTupleHeaderGetRawXmin(tuple)))
  			SetHintBits(tuple, buffer, HEAP_XMIN_COMMITTED,
! 						HeapTupleHeaderGetRawXmin(tuple));
  		else
  		{
  			/* it must have aborted or crashed */
--- 1054,1064 ----
  			else
  				return false;	/* deleted before scan started */
  		}
! 		else if (XidInMVCCSnapshot(HeapTupleGetRawXmin(htup), snapshot))
  			return false;
! 		else if (TransactionIdDidCommit(HeapTupleGetRawXmin(htup)))
  			SetHintBits(tuple, buffer, HEAP_XMIN_COMMITTED,
! 						HeapTupleGetRawXmin(htup));
  		else
  		{
  			/* it must have aborted or crashed */
*************** HeapTupleSatisfiesMVCC(HeapTuple htup, S
*** 1071,1077 ****
  	{
  		/* xmin is committed, but maybe not according to our snapshot */
  		if (!HeapTupleHeaderXminFrozen(tuple) &&
! 			XidInMVCCSnapshot(HeapTupleHeaderGetRawXmin(tuple), snapshot))
  			return false;		/* treat as still in progress */
  	}
  
--- 1071,1077 ----
  	{
  		/* xmin is committed, but maybe not according to our snapshot */
  		if (!HeapTupleHeaderXminFrozen(tuple) &&
! 			XidInMVCCSnapshot(HeapTupleGetRawXmin(htup), snapshot))
  			return false;		/* treat as still in progress */
  	}
  
*************** HeapTupleSatisfiesMVCC(HeapTuple htup, S
*** 1090,1096 ****
  		/* already checked above */
  		Assert(!HEAP_XMAX_IS_LOCKED_ONLY(tuple->t_infomask));
  
! 		xmax = HeapTupleGetUpdateXid(tuple);
  
  		/* not LOCKED_ONLY, so it has to have an xmax */
  		Assert(TransactionIdIsValid(xmax));
--- 1090,1096 ----
  		/* already checked above */
  		Assert(!HEAP_XMAX_IS_LOCKED_ONLY(tuple->t_infomask));
  
! 		xmax = HeapTupleGetUpdateXid(htup);
  
  		/* not LOCKED_ONLY, so it has to have an xmax */
  		Assert(TransactionIdIsValid(xmax));
*************** HeapTupleSatisfiesMVCC(HeapTuple htup, S
*** 1112,1118 ****
  
  	if (!(tuple->t_infomask & HEAP_XMAX_COMMITTED))
  	{
! 		if (TransactionIdIsCurrentTransactionId(HeapTupleHeaderGetRawXmax(tuple)))
  		{
  			if (HeapTupleHeaderGetCmax(tuple) >= snapshot->curcid)
  				return true;	/* deleted after scan started */
--- 1112,1118 ----
  
  	if (!(tuple->t_infomask & HEAP_XMAX_COMMITTED))
  	{
! 		if (TransactionIdIsCurrentTransactionId(HeapTupleGetRawXmax(htup)))
  		{
  			if (HeapTupleHeaderGetCmax(tuple) >= snapshot->curcid)
  				return true;	/* deleted after scan started */
*************** HeapTupleSatisfiesMVCC(HeapTuple htup, S
*** 1120,1129 ****
  				return false;	/* deleted before scan started */
  		}
  
! 		if (XidInMVCCSnapshot(HeapTupleHeaderGetRawXmax(tuple), snapshot))
  			return true;
  
! 		if (!TransactionIdDidCommit(HeapTupleHeaderGetRawXmax(tuple)))
  		{
  			/* it must have aborted or crashed */
  			SetHintBits(tuple, buffer, HEAP_XMAX_INVALID,
--- 1120,1129 ----
  				return false;	/* deleted before scan started */
  		}
  
! 		if (XidInMVCCSnapshot(HeapTupleGetRawXmax(htup), snapshot))
  			return true;
  
! 		if (!TransactionIdDidCommit(HeapTupleGetRawXmax(htup)))
  		{
  			/* it must have aborted or crashed */
  			SetHintBits(tuple, buffer, HEAP_XMAX_INVALID,
*************** HeapTupleSatisfiesMVCC(HeapTuple htup, S
*** 1133,1144 ****
  
  		/* xmax transaction committed */
  		SetHintBits(tuple, buffer, HEAP_XMAX_COMMITTED,
! 					HeapTupleHeaderGetRawXmax(tuple));
  	}
  	else
  	{
  		/* xmax is committed, but maybe not according to our snapshot */
! 		if (XidInMVCCSnapshot(HeapTupleHeaderGetRawXmax(tuple), snapshot))
  			return true;		/* treat as still in progress */
  	}
  
--- 1133,1144 ----
  
  		/* xmax transaction committed */
  		SetHintBits(tuple, buffer, HEAP_XMAX_COMMITTED,
! 					HeapTupleGetRawXmax(htup));
  	}
  	else
  	{
  		/* xmax is committed, but maybe not according to our snapshot */
! 		if (XidInMVCCSnapshot(HeapTupleGetRawXmax(htup), snapshot))
  			return true;		/* treat as still in progress */
  	}
  
*************** HeapTupleSatisfiesVacuum(HeapTuple htup,
*** 1216,1236 ****
  				return HEAPTUPLE_DEAD;
  			}
  		}
! 		else if (TransactionIdIsCurrentTransactionId(HeapTupleHeaderGetRawXmin(tuple)))
  		{
  			if (tuple->t_infomask & HEAP_XMAX_INVALID)	/* xid invalid */
  				return HEAPTUPLE_INSERT_IN_PROGRESS;
  			/* only locked? run infomask-only check first, for performance */
  			if (HEAP_XMAX_IS_LOCKED_ONLY(tuple->t_infomask) ||
! 				HeapTupleHeaderIsOnlyLocked(tuple))
  				return HEAPTUPLE_INSERT_IN_PROGRESS;
  			/* inserted and then deleted by same xact */
! 			if (TransactionIdIsCurrentTransactionId(HeapTupleHeaderGetUpdateXid(tuple)))
  				return HEAPTUPLE_DELETE_IN_PROGRESS;
  			/* deleting subtransaction must have aborted */
  			return HEAPTUPLE_INSERT_IN_PROGRESS;
  		}
! 		else if (TransactionIdIsInProgress(HeapTupleHeaderGetRawXmin(tuple)))
  		{
  			/*
  			 * It'd be possible to discern between INSERT/DELETE in progress
--- 1216,1236 ----
  				return HEAPTUPLE_DEAD;
  			}
  		}
! 		else if (TransactionIdIsCurrentTransactionId(HeapTupleGetRawXmin(htup)))
  		{
  			if (tuple->t_infomask & HEAP_XMAX_INVALID)	/* xid invalid */
  				return HEAPTUPLE_INSERT_IN_PROGRESS;
  			/* only locked? run infomask-only check first, for performance */
  			if (HEAP_XMAX_IS_LOCKED_ONLY(tuple->t_infomask) ||
! 				HeapTupleHeaderIsOnlyLocked(htup))
  				return HEAPTUPLE_INSERT_IN_PROGRESS;
  			/* inserted and then deleted by same xact */
! 			if (TransactionIdIsCurrentTransactionId(HeapTupleGetUpdateXidAny(htup)))
  				return HEAPTUPLE_DELETE_IN_PROGRESS;
  			/* deleting subtransaction must have aborted */
  			return HEAPTUPLE_INSERT_IN_PROGRESS;
  		}
! 		else if (TransactionIdIsInProgress(HeapTupleGetRawXmin(htup)))
  		{
  			/*
  			 * It'd be possible to discern between INSERT/DELETE in progress
*************** HeapTupleSatisfiesVacuum(HeapTuple htup,
*** 1242,1250 ****
  			 */
  			return HEAPTUPLE_INSERT_IN_PROGRESS;
  		}
! 		else if (TransactionIdDidCommit(HeapTupleHeaderGetRawXmin(tuple)))
  			SetHintBits(tuple, buffer, HEAP_XMIN_COMMITTED,
! 						HeapTupleHeaderGetRawXmin(tuple));
  		else
  		{
  			/*
--- 1242,1250 ----
  			 */
  			return HEAPTUPLE_INSERT_IN_PROGRESS;
  		}
! 		else if (TransactionIdDidCommit(HeapTupleGetRawXmin(htup)))
  			SetHintBits(tuple, buffer, HEAP_XMIN_COMMITTED,
! 						HeapTupleGetRawXmin(htup));
  		else
  		{
  			/*
*************** HeapTupleSatisfiesVacuum(HeapTuple htup,
*** 1286,1299 ****
  				 * possibly be running; otherwise have to check.
  				 */
  				if (!HEAP_LOCKED_UPGRADED(tuple->t_infomask) &&
! 					MultiXactIdIsRunning(HeapTupleHeaderGetRawXmax(tuple),
  										 true))
  					return HEAPTUPLE_LIVE;
  				SetHintBits(tuple, buffer, HEAP_XMAX_INVALID, InvalidTransactionId);
  			}
  			else
  			{
! 				if (TransactionIdIsInProgress(HeapTupleHeaderGetRawXmax(tuple)))
  					return HEAPTUPLE_LIVE;
  				SetHintBits(tuple, buffer, HEAP_XMAX_INVALID,
  							InvalidTransactionId);
--- 1286,1299 ----
  				 * possibly be running; otherwise have to check.
  				 */
  				if (!HEAP_LOCKED_UPGRADED(tuple->t_infomask) &&
! 					MultiXactIdIsRunning(HeapTupleGetRawXmax(htup),
  										 true))
  					return HEAPTUPLE_LIVE;
  				SetHintBits(tuple, buffer, HEAP_XMAX_INVALID, InvalidTransactionId);
  			}
  			else
  			{
! 				if (TransactionIdIsInProgress(HeapTupleGetRawXmax(htup)))
  					return HEAPTUPLE_LIVE;
  				SetHintBits(tuple, buffer, HEAP_XMAX_INVALID,
  							InvalidTransactionId);
*************** HeapTupleSatisfiesVacuum(HeapTuple htup,
*** 1313,1324 ****
  	{
  		TransactionId xmax;
  
! 		if (MultiXactIdIsRunning(HeapTupleHeaderGetRawXmax(tuple), false))
  		{
  			/* already checked above */
  			Assert(!HEAP_XMAX_IS_LOCKED_ONLY(tuple->t_infomask));
  
! 			xmax = HeapTupleGetUpdateXid(tuple);
  
  			/* not LOCKED_ONLY, so it has to have an xmax */
  			Assert(TransactionIdIsValid(xmax));
--- 1313,1324 ----
  	{
  		TransactionId xmax;
  
! 		if (MultiXactIdIsRunning(HeapTupleGetRawXmax(htup), false))
  		{
  			/* already checked above */
  			Assert(!HEAP_XMAX_IS_LOCKED_ONLY(tuple->t_infomask));
  
! 			xmax = HeapTupleGetUpdateXid(htup);
  
  			/* not LOCKED_ONLY, so it has to have an xmax */
  			Assert(TransactionIdIsValid(xmax));
*************** HeapTupleSatisfiesVacuum(HeapTuple htup,
*** 1334,1340 ****
  
  		Assert(!(tuple->t_infomask & HEAP_XMAX_COMMITTED));
  
! 		xmax = HeapTupleGetUpdateXid(tuple);
  
  		/* not LOCKED_ONLY, so it has to have an xmax */
  		Assert(TransactionIdIsValid(xmax));
--- 1334,1340 ----
  
  		Assert(!(tuple->t_infomask & HEAP_XMAX_COMMITTED));
  
! 		xmax = HeapTupleGetUpdateXid(htup);
  
  		/* not LOCKED_ONLY, so it has to have an xmax */
  		Assert(TransactionIdIsValid(xmax));
*************** HeapTupleSatisfiesVacuum(HeapTuple htup,
*** 1359,1369 ****
  
  	if (!(tuple->t_infomask & HEAP_XMAX_COMMITTED))
  	{
! 		if (TransactionIdIsInProgress(HeapTupleHeaderGetRawXmax(tuple)))
  			return HEAPTUPLE_DELETE_IN_PROGRESS;
! 		else if (TransactionIdDidCommit(HeapTupleHeaderGetRawXmax(tuple)))
  			SetHintBits(tuple, buffer, HEAP_XMAX_COMMITTED,
! 						HeapTupleHeaderGetRawXmax(tuple));
  		else
  		{
  			/*
--- 1359,1369 ----
  
  	if (!(tuple->t_infomask & HEAP_XMAX_COMMITTED))
  	{
! 		if (TransactionIdIsInProgress(HeapTupleGetRawXmax(htup)))
  			return HEAPTUPLE_DELETE_IN_PROGRESS;
! 		else if (TransactionIdDidCommit(HeapTupleGetRawXmax(htup)))
  			SetHintBits(tuple, buffer, HEAP_XMAX_COMMITTED,
! 						HeapTupleGetRawXmax(htup));
  		else
  		{
  			/*
*************** HeapTupleSatisfiesVacuum(HeapTuple htup,
*** 1385,1391 ****
  	 * Deleter committed, but perhaps it was recent enough that some open
  	 * transactions could still see the tuple.
  	 */
! 	if (!TransactionIdPrecedes(HeapTupleHeaderGetRawXmax(tuple), OldestXmin))
  		return HEAPTUPLE_RECENTLY_DEAD;
  
  	/* Otherwise, it's dead and removable */
--- 1385,1391 ----
  	 * Deleter committed, but perhaps it was recent enough that some open
  	 * transactions could still see the tuple.
  	 */
! 	if (!TransactionIdPrecedes(HeapTupleGetRawXmax(htup), OldestXmin))
  		return HEAPTUPLE_RECENTLY_DEAD;
  
  	/* Otherwise, it's dead and removable */
*************** HeapTupleIsSurelyDead(HeapTuple htup, Tr
*** 1447,1453 ****
  		return false;
  
  	/* Deleter committed, so tuple is dead if the XID is old enough. */
! 	return TransactionIdPrecedes(HeapTupleHeaderGetRawXmax(tuple), OldestXmin);
  }
  
  /*
--- 1447,1453 ----
  		return false;
  
  	/* Deleter committed, so tuple is dead if the XID is old enough. */
! 	return TransactionIdPrecedes(HeapTupleGetRawXmax(htup), OldestXmin);
  }
  
  /*
*************** XidInMVCCSnapshot(TransactionId xid, Sna
*** 1582,1589 ****
   * laid out at the top of this file.
   */
  bool
! HeapTupleHeaderIsOnlyLocked(HeapTupleHeader tuple)
  {
  	TransactionId xmax;
  
  	/* if there's no valid Xmax, then there's obviously no update either */
--- 1582,1590 ----
   * laid out at the top of this file.
   */
  bool
! HeapTupleHeaderIsOnlyLocked(HeapTuple htup)
  {
+ 	HeapTupleHeader tuple = htup->t_data;
  	TransactionId xmax;
  
  	/* if there's no valid Xmax, then there's obviously no update either */
*************** HeapTupleHeaderIsOnlyLocked(HeapTupleHea
*** 1594,1600 ****
  		return true;
  
  	/* invalid xmax means no update */
! 	if (!TransactionIdIsValid(HeapTupleHeaderGetRawXmax(tuple)))
  		return true;
  
  	/*
--- 1595,1601 ----
  		return true;
  
  	/* invalid xmax means no update */
! 	if (!TransactionIdIsValid(HeapTupleGetRawXmax(htup)))
  		return true;
  
  	/*
*************** HeapTupleHeaderIsOnlyLocked(HeapTupleHea
*** 1605,1611 ****
  		return false;
  
  	/* ... but if it's a multi, then perhaps the updating Xid aborted. */
! 	xmax = HeapTupleGetUpdateXid(tuple);
  
  	/* not LOCKED_ONLY, so it has to have an xmax */
  	Assert(TransactionIdIsValid(xmax));
--- 1606,1612 ----
  		return false;
  
  	/* ... but if it's a multi, then perhaps the updating Xid aborted. */
! 	xmax = HeapTupleGetUpdateXid(htup);
  
  	/* not LOCKED_ONLY, so it has to have an xmax */
  	Assert(TransactionIdIsValid(xmax));
*************** HeapTupleSatisfiesHistoricMVCC(HeapTuple
*** 1653,1660 ****
  							   Buffer buffer)
  {
  	HeapTupleHeader tuple = htup->t_data;
! 	TransactionId xmin = HeapTupleHeaderGetXmin(tuple);
! 	TransactionId xmax = HeapTupleHeaderGetRawXmax(tuple);
  
  	Assert(ItemPointerIsValid(&htup->t_self));
  	Assert(htup->t_tableOid != InvalidOid);
--- 1654,1661 ----
  							   Buffer buffer)
  {
  	HeapTupleHeader tuple = htup->t_data;
! 	TransactionId xmin = HeapTupleGetXmin(htup);
! 	TransactionId xmax = HeapTupleGetRawXmax(htup);
  
  	Assert(ItemPointerIsValid(&htup->t_self));
  	Assert(htup->t_tableOid != InvalidOid);
*************** HeapTupleSatisfiesHistoricMVCC(HeapTuple
*** 1737,1743 ****
  	 */
  	else if (tuple->t_infomask & HEAP_XMAX_IS_MULTI)
  	{
! 		xmax = HeapTupleGetUpdateXid(tuple);
  	}
  
  	/* check if it's one of our txids, toplevel is also in there */
--- 1738,1744 ----
  	 */
  	else if (tuple->t_infomask & HEAP_XMAX_IS_MULTI)
  	{
! 		xmax = HeapTupleGetUpdateXid(htup);
  	}
  
  	/* check if it's one of our txids, toplevel is also in there */
